export class Roller {
    history: Roll[];
    pool: number;
    dt: number;
    con: number;

    constructor() {
        this.history = [];
        this.pool = 7;
        this.dt = 6;
        this.con = 3;
    }

    public roll() {
        this.history.unshift(new Roll(this.pool, this.dt));

        // console.log(this.history[0]);
        // console.log(this.history[0].failures)

        this.pool = Math.max(this.pool - this.history[0].failures, 0) + this.con;
    }
}

export class Roll {
    readonly rolls: number[];
    readonly dt: number;

    constructor(d: number, dt: number) {

        this.dt = dt;

        const rolls = [];

        for (let i = 0; i < d; i++) {
            rolls[i] = Math.floor(Math.random() * 12 + 1);
        }

        this.rolls = rolls;
    }

    public get margin(): number {
        const cf = this.rolls.filter((r) => r == 1).length;
        const f = this.rolls.filter((r) => r > 1 && r <= this.dt).length;
        const s = this.rolls.filter((r) => r < 12 && r > this.dt).length;
        const cs = this.rolls.filter((r) => r == 12).length;

        return 2 * cs + s - f - 2 * cf;
    }

    public get failures(): number {
        const cf = this.rolls.filter((r) => r == 1).length;
        const f = this.rolls.filter((r) => r > 1 && r <= this.dt).length;

        return cf + f;
    }
}